
# Autogenerated by mlir-tblgen; don't manually edit.

from ._ods_common import _cext as _ods_cext
from ._ods_common import extend_opview_class as _ods_extend_opview_class, segmented_accessor as _ods_segmented_accessor, equally_sized_accessor as _ods_equally_sized_accessor, get_default_loc_context as _ods_get_default_loc_context, get_op_result_or_value as _get_op_result_or_value, get_op_results_or_values as _get_op_results_or_values
_ods_ir = _ods_cext.ir

try:
  from . import _gradient_ops_ext as _ods_ext_module
except ImportError:
  _ods_ext_module = None

import builtins


@_ods_cext.register_dialect
class _Dialect(_ods_ir.Dialect):
  DIALECT_NAMESPACE = "gradient"
  pass


@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class AdjointOp(_ods_ir.OpView):
  OPERATION_NAME = "gradient.adjoint"

  _ODS_OPERAND_SEGMENTS = [1,-1,-1,]

  _ODS_REGIONS = (0, True)

  def __init__(self, result, callee, gradSize, args, data_in, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(gradSize))
    operands.append(_get_op_results_or_values(args))
    operands.append(_get_op_results_or_values(data_in))
    _ods_context = _ods_get_default_loc_context(loc)
    attributes["callee"] = (callee if (
    issubclass(type(callee), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('FlatSymbolRefAttr')) else
      _ods_ir.AttrBuilder.get('FlatSymbolRefAttr')(callee, context=_ods_context))
    results.extend(result)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def gradSize(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 0)
    return operand_range[0]

  @builtins.property
  def args(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 1)
    return operand_range

  @builtins.property
  def data_in(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 2)
    return operand_range

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class BackpropOp(_ods_ir.OpView):
  OPERATION_NAME = "gradient.backprop"

  _ODS_OPERAND_SEGMENTS = [-1,-1,-1,]

  _ODS_REGIONS = (0, True)

  def __init__(self, result, callee, diffArgIndices, args, quantum_jacobian, data_in, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_results_or_values(args))
    operands.append(_get_op_results_or_values(quantum_jacobian))
    operands.append(_get_op_results_or_values(data_in))
    _ods_context = _ods_get_default_loc_context(loc)
    attributes["callee"] = (callee if (
    issubclass(type(callee), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('FlatSymbolRefAttr')) else
      _ods_ir.AttrBuilder.get('FlatSymbolRefAttr')(callee, context=_ods_context))
    attributes["diffArgIndices"] = (diffArgIndices if (
    issubclass(type(diffArgIndices), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('AnyIntElementsAttr')) else
      _ods_ir.AttrBuilder.get('AnyIntElementsAttr')(diffArgIndices, context=_ods_context))
    results.extend(result)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def args(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 0)
    return operand_range

  @builtins.property
  def quantum_jacobian(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 1)
    return operand_range

  @builtins.property
  def data_in(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 2)
    return operand_range

  @builtins.property
  def diffArgIndices(self):
    return _ods_ir.DenseIntElementsAttr(self.operation.attributes["diffArgIndices"])

  @diffArgIndices.setter
  def diffArgIndices(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["diffArgIndices"] = value

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class GradOp(_ods_ir.OpView):
  OPERATION_NAME = "gradient.grad"

  _ODS_REGIONS = (0, True)

  def __init__(self, result, method, callee, operands_, *, diffArgIndices=None, finiteDiffParam=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.extend(_get_op_results_or_values(operands_))
    _ods_context = _ods_get_default_loc_context(loc)
    attributes["method"] = (method if (
    issubclass(type(method), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('StrAttr')) else
      _ods_ir.AttrBuilder.get('StrAttr')(method, context=_ods_context))
    attributes["callee"] = (callee if (
    issubclass(type(callee), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('FlatSymbolRefAttr')) else
      _ods_ir.AttrBuilder.get('FlatSymbolRefAttr')(callee, context=_ods_context))
    if diffArgIndices is not None: attributes["diffArgIndices"] = (diffArgIndices if (
        issubclass(type(diffArgIndices), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('AnyIntElementsAttr')) else
          _ods_ir.AttrBuilder.get('AnyIntElementsAttr')(diffArgIndices, context=_ods_context))
    if finiteDiffParam is not None: attributes["finiteDiffParam"] = (finiteDiffParam if (
        issubclass(type(finiteDiffParam), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('Builtin_FloatAttr')) else
          _ods_ir.AttrBuilder.get('Builtin_FloatAttr')(finiteDiffParam, context=_ods_context))
    results.extend(result)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def operands_(self):
    _ods_variadic_group_length = len(self.operation.operands) - 1 + 1
    return self.operation.operands[0:0 + _ods_variadic_group_length]

  @builtins.property
  def method(self):
    return _ods_ir.StringAttr(self.operation.attributes["method"])

  @method.setter
  def method(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["method"] = value

  @builtins.property
  def diffArgIndices(self):
    if "diffArgIndices" not in self.operation.attributes:
      return None
    return _ods_ir.DenseIntElementsAttr(self.operation.attributes["diffArgIndices"])

  @diffArgIndices.setter
  def diffArgIndices(self, value):
    if value is not None:
      self.operation.attributes["diffArgIndices"] = value
    elif "diffArgIndices" in self.operation.attributes:
      del self.operation.attributes["diffArgIndices"]

  @diffArgIndices.deleter
  def diffArgIndices(self):
    del self.operation.attributes["diffArgIndices"]

  @builtins.property
  def finiteDiffParam(self):
    if "finiteDiffParam" not in self.operation.attributes:
      return None
    return _ods_ir.FloatAttr(self.operation.attributes["finiteDiffParam"])

  @finiteDiffParam.setter
  def finiteDiffParam(self, value):
    if value is not None:
      self.operation.attributes["finiteDiffParam"] = value
    elif "finiteDiffParam" in self.operation.attributes:
      del self.operation.attributes["finiteDiffParam"]

  @finiteDiffParam.deleter
  def finiteDiffParam(self):
    del self.operation.attributes["finiteDiffParam"]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class JVPOp(_ods_ir.OpView):
  OPERATION_NAME = "gradient.jvp"

  _ODS_OPERAND_SEGMENTS = [-1,-1,]

  _ODS_REGIONS = (0, True)

  def __init__(self, calleeResults, jvps, method, callee, params, tangents, *, diffArgIndices=None, finiteDiffParam=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_results_or_values(params))
    operands.append(_get_op_results_or_values(tangents))
    _ods_context = _ods_get_default_loc_context(loc)
    attributes["method"] = (method if (
    issubclass(type(method), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('StrAttr')) else
      _ods_ir.AttrBuilder.get('StrAttr')(method, context=_ods_context))
    attributes["callee"] = (callee if (
    issubclass(type(callee), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('FlatSymbolRefAttr')) else
      _ods_ir.AttrBuilder.get('FlatSymbolRefAttr')(callee, context=_ods_context))
    if diffArgIndices is not None: attributes["diffArgIndices"] = (diffArgIndices if (
        issubclass(type(diffArgIndices), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('AnyIntElementsAttr')) else
          _ods_ir.AttrBuilder.get('AnyIntElementsAttr')(diffArgIndices, context=_ods_context))
    if finiteDiffParam is not None: attributes["finiteDiffParam"] = (finiteDiffParam if (
        issubclass(type(finiteDiffParam), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('Builtin_FloatAttr')) else
          _ods_ir.AttrBuilder.get('Builtin_FloatAttr')(finiteDiffParam, context=_ods_context))
    results.extend(calleeResults)
    results.extend(jvps)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def params(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 0)
    return operand_range

  @builtins.property
  def tangents(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 1)
    return operand_range

  @builtins.property
  def method(self):
    return _ods_ir.StringAttr(self.operation.attributes["method"])

  @method.setter
  def method(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["method"] = value

  @builtins.property
  def diffArgIndices(self):
    if "diffArgIndices" not in self.operation.attributes:
      return None
    return _ods_ir.DenseIntElementsAttr(self.operation.attributes["diffArgIndices"])

  @diffArgIndices.setter
  def diffArgIndices(self, value):
    if value is not None:
      self.operation.attributes["diffArgIndices"] = value
    elif "diffArgIndices" in self.operation.attributes:
      del self.operation.attributes["diffArgIndices"]

  @diffArgIndices.deleter
  def diffArgIndices(self):
    del self.operation.attributes["diffArgIndices"]

  @builtins.property
  def finiteDiffParam(self):
    if "finiteDiffParam" not in self.operation.attributes:
      return None
    return _ods_ir.FloatAttr(self.operation.attributes["finiteDiffParam"])

  @finiteDiffParam.setter
  def finiteDiffParam(self, value):
    if value is not None:
      self.operation.attributes["finiteDiffParam"] = value
    elif "finiteDiffParam" in self.operation.attributes:
      del self.operation.attributes["finiteDiffParam"]

  @finiteDiffParam.deleter
  def finiteDiffParam(self):
    del self.operation.attributes["finiteDiffParam"]

  @builtins.property
  def calleeResults(self):
    start, pg = _ods_equally_sized_accessor(operation.results, 2, 0, 0)
    return self.operation.results[start:start + pg]

  @builtins.property
  def jvps(self):
    start, pg = _ods_equally_sized_accessor(operation.results, 2, 0, 1)
    return self.operation.results[start:start + pg]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class VJPOp(_ods_ir.OpView):
  OPERATION_NAME = "gradient.vjp"

  _ODS_OPERAND_SEGMENTS = [-1,-1,]

  _ODS_RESULT_SEGMENTS = [-1,-1,]

  _ODS_REGIONS = (0, True)

  def __init__(self, calleeResults, vjps, method, callee, params, cotangents, *, diffArgIndices=None, finiteDiffParam=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_results_or_values(params))
    operands.append(_get_op_results_or_values(cotangents))
    _ods_context = _ods_get_default_loc_context(loc)
    attributes["method"] = (method if (
    issubclass(type(method), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('StrAttr')) else
      _ods_ir.AttrBuilder.get('StrAttr')(method, context=_ods_context))
    attributes["callee"] = (callee if (
    issubclass(type(callee), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('FlatSymbolRefAttr')) else
      _ods_ir.AttrBuilder.get('FlatSymbolRefAttr')(callee, context=_ods_context))
    if diffArgIndices is not None: attributes["diffArgIndices"] = (diffArgIndices if (
        issubclass(type(diffArgIndices), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('AnyIntElementsAttr')) else
          _ods_ir.AttrBuilder.get('AnyIntElementsAttr')(diffArgIndices, context=_ods_context))
    if finiteDiffParam is not None: attributes["finiteDiffParam"] = (finiteDiffParam if (
        issubclass(type(finiteDiffParam), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('Builtin_FloatAttr')) else
          _ods_ir.AttrBuilder.get('Builtin_FloatAttr')(finiteDiffParam, context=_ods_context))
    results.append(calleeResults)
    results.append(vjps)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def params(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 0)
    return operand_range

  @builtins.property
  def cotangents(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 1)
    return operand_range

  @builtins.property
  def method(self):
    return _ods_ir.StringAttr(self.operation.attributes["method"])

  @method.setter
  def method(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["method"] = value

  @builtins.property
  def diffArgIndices(self):
    if "diffArgIndices" not in self.operation.attributes:
      return None
    return _ods_ir.DenseIntElementsAttr(self.operation.attributes["diffArgIndices"])

  @diffArgIndices.setter
  def diffArgIndices(self, value):
    if value is not None:
      self.operation.attributes["diffArgIndices"] = value
    elif "diffArgIndices" in self.operation.attributes:
      del self.operation.attributes["diffArgIndices"]

  @diffArgIndices.deleter
  def diffArgIndices(self):
    del self.operation.attributes["diffArgIndices"]

  @builtins.property
  def finiteDiffParam(self):
    if "finiteDiffParam" not in self.operation.attributes:
      return None
    return _ods_ir.FloatAttr(self.operation.attributes["finiteDiffParam"])

  @finiteDiffParam.setter
  def finiteDiffParam(self, value):
    if value is not None:
      self.operation.attributes["finiteDiffParam"] = value
    elif "finiteDiffParam" in self.operation.attributes:
      del self.operation.attributes["finiteDiffParam"]

  @finiteDiffParam.deleter
  def finiteDiffParam(self):
    del self.operation.attributes["finiteDiffParam"]

  @builtins.property
  def calleeResults(self):
    result_range = _ods_segmented_accessor(
         self.operation.results,
         self.operation.attributes["result_segment_sizes"], 0)
    return result_range

  @builtins.property
  def vjps(self):
    result_range = _ods_segmented_accessor(
         self.operation.results,
         self.operation.attributes["result_segment_sizes"], 1)
    return result_range
